/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.STCMCUDATA.com  ---------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* 如果要在程序中使用此代码,请在程序中注明使用了STC的资料及程序            */
/*---------------------------------------------------------------------*/


/*************  技术支持与购买说明    **************
产品主页：http://tw51.haohaodada.com
淘宝搜索：天问51，可购买。目前基础版99元，带彩屏标准版149元
技术支持QQ群一：1138055784
******************************************/


/*************  本程序功能说明  **************

红外收发程序。适用于市场上用量最大的NEC编码。

应用层查询 B_IR_Press标志为,则已接收到一个键码放在IR_code中, 处理完键码后， 用户程序清除B_IR_Press标志.

数码管左起4位显示用户码, 最右边两位显示数据, 均为十六进制.

用户可以在宏定义中指定用户码.

用户底层程序按固定的时间间隔(60~125us)调用 "IR_RX_NEC()"函数.

按下IO行列键（不支持ADC键盘），显示发送、接收到的键值。

下载时, 选择时钟 24MHz (用户可自行修改频率).

******************************************/
#include "sys.h"
#include "intrins.h"
#include "delay.h"
#include "hc595.h"
#include "led8.h"
#include "nixietube.h"

#define SysTick 14225   // 次/秒, 系统滴答频率, 在4000~16000之间
#define Timer0_Reload   (65536UL - ((MAIN_Fosc + SysTick/2) / SysTick))     //Timer 0 中断频率
#define User_code   0xFF00      //定义红外用户码

/*************  IO口定义    **************/

sbit P_IR_TX = P2^0;    //定义红外发送脚
sbit P_IR_RX = P3^6;    //定义红外接收输入IO口

/*************  本地变量声明    **************/
bit B_1ms;          //1ms标志
u8  cnt_1ms;        //1ms基本计时

u8  IO_KeyState, IO_KeyState1, IO_KeyHoldCnt;   //行列键盘变量
u8  KeyHoldCnt; //键按下计时
u8  KeyCode;    //给用户使用的键码, 1~16有效
u8  cnt_27ms;

/*************  红外发送程序变量声明    **************/

u16 tx_cnt;    //发送或空闲的脉冲计数(等于38KHZ的脉冲数，对应时间), 红外频率为38KHZ, 周期26.3us

/*************  红外接收程序变量声明    **************/

u8  IR_SampleCnt;       //采样计数
u8  IR_BitCnt;          //编码位数
u8  IR_UserH;           //用户码(地址)高字节
u8  IR_UserL;           //用户码(地址)低字节
u8  IR_data;            //数据原码
u8  IR_DataShit;        //数据移位

bit P_IR_RX_temp;       //Last sample
bit B_IR_Sync;          //已收到同步标志
bit B_IR_Press;         //按键动作发生
u8  IR_code;            //红外键码
u16 UserCode;           //用户码

/*************  本地函数声明    **************/
void    IO_KeyScan(void);
void    PWM_config(void);
void    IR_TxPulse(u16 pulse);
void    IR_TxSpace(u16 pulse);
void    IR_TxByte(u8 dat);
/********************** 主函数 ************************/
void main(void)
{
//		P_SW2 = 0x80;						//启用外部晶振
//		XOSCCR = 0xc0;
//		while(!(XOSCCR & 0x01));
//		CLKDIV = 0x00;
//		CKSEL = 0x01;
//		P_SW2 = 0x00;
	
    P0M1 = 0;   P0M0 = 0;   //设置为准双向口
    P1M1 = 0;   P1M0 = 0;   //设置为准双向口
    P2M1 = 0;   P2M0 = 0;   //设置为准双向口
    P3M1 = 0;   P3M0 = 0;   //设置为准双向口
    P4M1 = 0;   P4M0 = 0;   //设置为准双向口
    P5M1 = 0;   P5M0 = 0;   //设置为准双向口
    P6M1 = 0;   P6M0 = 0;   //设置为准双向口
    P7M1 = 0;   P7M0 = 0;   //设置为准双向口

		led8_disable();					//LED Power OFF
    hc595_init(); 
//   	hc595_disable();
		nix_init();
	
    AUXR = 0x80;    //Timer0 set as 1T, 16 bits timer auto-reload, 
    TH0 = (u8)(Timer0_Reload / 256);
    TL0 = (u8)(Timer0_Reload % 256);
    ET0 = 1;    //Timer0 interrupt enable
    TR0 = 1;    //Tiner0 run
		cnt_1ms = SysTick / 1000;
    EA = 1;     //打开总中断
    
    PWM_config();
    
		nix_display_clear();

    while(1)
    {
        if(B_1ms)   //1ms到
        {
            B_1ms = 0;
						nix_scan_callback();
            if(++cnt_27ms >= 27)
            {
                cnt_27ms = 0;
                IO_KeyScan();

                if(KeyCode > 0) 
                {
                    IR_TxPulse(342);    //对应9ms，同步头       9ms
                    IR_TxSpace(171);    //对应4.5ms，同步头间隔 4.5ms
                    IR_TxPulse(21);     //开始发送数据          0.5625ms

                    IR_TxByte(User_code%256);   //发用户码低字节
                    IR_TxByte(User_code/256);   //发用户码高字节
                    IR_TxByte(KeyCode);         //发数据
                    IR_TxByte(~KeyCode);        //发数据反码
									
                    KeyCode = 0;
                }
            }

            if(B_IR_Press)      //检测到收到红外键码
            {
                B_IR_Press = 0;
                P41 = ~P41;
                nix_display_bit(7,(u8)((UserCode >> 12) & 0x0f));
								nix_display_bit(6,(u8)((UserCode >> 8)  & 0x0f));
								nix_display_bit(5,(u8)((UserCode >> 4)  & 0x0f));
								nix_display_bit(4,(u8)(UserCode & 0x0f));
								nix_display_bit(1,IR_code >> 4);
								nix_display_bit(0,IR_code & 0x0f);
            }
        }
    }
} 

/*****************************************************
    行列键扫描程序
    使用XY查找4x4键的方法，只能单键，速度快

   Y     P70      P71      P72      P73
          |        |        |        |
X         |        |        |        |
P74 ----  +  ----  9  ----  8  ----  7  ----
          |        |        |        |
P75 ----  -  ----  6  ----  5  ----  4  ----
          |        |        |        |
P76 ----  x  ----  3  ----  2  ----  1  ----
          |        |        |        |
P77 ----  ÷  ----  #  ----  0  ----  * ----
          |        |        |        |
******************************************************/

u8 code T_KeyTable[16] = {0,1,2,0,3,0,0,0,4,0,0,0,0,0,0,0};

void IO_KeyDelay(void)
{
    u8 i;
    i = 60;
    while(--i)  ;
}

void IO_KeyScan(void)    //50ms call
{
    u8  j;

    j = IO_KeyState1;   //保存上一次状态

    P7 = 0xf0;  //X低，读Y
    IO_KeyDelay();
    IO_KeyState1 = P7 & 0xf0;

    P7 = 0x0f;  //Y低，读X
    IO_KeyDelay();
    IO_KeyState1 |= (P7 & 0x0f);
    IO_KeyState1 ^= 0xff;   //取反
    
    if(j == IO_KeyState1)   //连续两次读相等
    {
        j = IO_KeyState;
        IO_KeyState = IO_KeyState1;
        if(IO_KeyState != 0)    //有键按下
        {
            F0 = 0;
            if(j == 0)  F0 = 1; //第一次按下
            else if(j == IO_KeyState)
            {
                if(++IO_KeyHoldCnt >= 20)   //1秒后重键
                {
                    IO_KeyHoldCnt = 18;
                    F0 = 1;
                }
            }
            if(F0)
            {
                j = T_KeyTable[IO_KeyState >> 4];
                if((j != 0) && (T_KeyTable[IO_KeyState& 0x0f] != 0)) 
                    KeyCode = (j - 1) * 4 + T_KeyTable[IO_KeyState & 0x0f] + 16;    //计算键码，17~32
            }
        }
        else    IO_KeyHoldCnt = 0;
    }
    P7 = 0xff;
}

//*******************************************************************
//*********************** IR Remote Module **************************
//*********************** By 梁深 (Coody) 2002-8-24 *****************
//*********************** IR Remote Module **************************
//this programme is used for Receive IR Remote (NEC Code).

//data format: Synchro, AddressH, AddressL, data, /data, (total 32 bit).

//send a frame(85ms), pause 23ms, send synchro of continue frame, pause 94ms

//data rate: 108ms/Frame


//Synchro: low=9ms, high=4.5 / 2.25ms, low=0.5626ms
//Bit0: high=0.5626ms, low=0.5626ms
//Bit1: high=1.6879ms, low=0.5626ms
//frame rate = 108ms ( pause 23 ms or 96 ms)

/******************** 红外采样时间宏定义, 用户不要随意修改  *******************/

#define IR_SAMPLE_TIME      (1000000UL/SysTick)         //查询时间间隔, us, 红外接收要求在60us~250us之间
#if ((IR_SAMPLE_TIME <= 250) && (IR_SAMPLE_TIME >= 60))
    #define D_IR_sample         IR_SAMPLE_TIME      //定义采样时间，在60us~250us之间
#endif

#define D_IR_SYNC_MAX       (15000/D_IR_sample) //SYNC max time
#define D_IR_SYNC_MIN       (9700 /D_IR_sample) //SYNC min time
#define D_IR_SYNC_DIVIDE    (12375/D_IR_sample) //decide data 0 or 1
#define D_IR_DATA_MAX       (3000 /D_IR_sample) //data max time
#define D_IR_DATA_MIN       (600  /D_IR_sample) //data min time
#define D_IR_DATA_DIVIDE    (1687 /D_IR_sample) //decide data 0 or 1
#define D_IR_BIT_NUMBER     32                  //bit number

//*******************************************************************************************
//**************************** IR RECEIVE MODULE ********************************************

void IR_RX_NEC(void)
{
    u8  SampleTime;

    IR_SampleCnt++;                         //Sample + 1

    F0 = P_IR_RX_temp;                      //Save Last sample status
    P_IR_RX_temp = P_IR_RX;                 //Read current status
    if(F0 && !P_IR_RX_temp)                 //Pre-sample is high，and current sample is low, so is fall edge
    {
        SampleTime = IR_SampleCnt;          //get the sample time
        IR_SampleCnt = 0;                   //Clear the sample counter

             if(SampleTime > D_IR_SYNC_MAX)     B_IR_Sync = 0;  //large the Maxim SYNC time, then error
        else if(SampleTime >= D_IR_SYNC_MIN)                    //SYNC
        {
            if(SampleTime >= D_IR_SYNC_DIVIDE)
            {
                B_IR_Sync = 1;                  //has received SYNC
                IR_BitCnt = D_IR_BIT_NUMBER;    //Load bit number
            }
        }
        else if(B_IR_Sync)                      //has received SYNC
        {
            if(SampleTime > D_IR_DATA_MAX)      B_IR_Sync=0;    //data samlpe time too large
            else
            {
                IR_DataShit >>= 1;                  //data shift right 1 bit
                if(SampleTime >= D_IR_DATA_DIVIDE)  IR_DataShit |= 0x80;    //devide data 0 or 1
                if(--IR_BitCnt == 0)                //bit number is over?
                {
                    B_IR_Sync = 0;                  //Clear SYNC
                    if(~IR_DataShit == IR_data)     //判断数据正反码
                    {
                        UserCode = ((u16)IR_UserH << 8) + IR_UserL;
                        IR_code      = IR_data;
                        B_IR_Press   = 1;           //数据有效
                    }
                }
                else if((IR_BitCnt & 7)== 0)        //one byte receive
                {
                    IR_UserL = IR_UserH;            //Save the User code high byte
                    IR_UserH = IR_data;             //Save the User code low byte
                    IR_data  = IR_DataShit;         //Save the IR data byte
                }
            }
        }
    }
}


/********************** Timer0 1ms中断函数 ************************/
void timer0 (void) interrupt 1
{
    IR_RX_NEC();
    if(--cnt_1ms == 0)
    {
        cnt_1ms = SysTick / 1000;
        B_1ms = 1;      //1ms标志
//        nix_scan_callback();  //1ms扫描显示一位
    }
}


/************* 发送脉冲函数 **************/
void    IR_TxPulse(u16 pulse)
{
    tx_cnt = pulse;
    PWM1_CCER1 = 0x00; //写 CCMRx 前必须先清零 CCxE 关闭通道
    PWM1_CCMR1 = 0x60; //设置 PWM1 模式1 输出
    PWM1_CCER1 = 0x0B; //使能 CC1E 通道, 低电平有效	
    PWM1_IER = 0x02;   //使能捕获/比较 1 中断
    while(tx_cnt);
}

/************* 发送空闲函数 **************/
void    IR_TxSpace(u16 pulse)
{
    tx_cnt = pulse;
    PWM1_CCER1 = 0x00; //写 CCMRx 前必须先清零 CCxE 关闭通道
    PWM1_CCMR1 = 0x40; //设置 PWM1 强制为无效电平
    PWM1_CCER1 = 0x03; //使能 CC1E 通道, 低电平有效	
    PWM1_IER = 0x02;   //使能捕获/比较 4 中断
    while(tx_cnt);
}

/************* 发送一个字节函数 **************/
void    IR_TxByte(u8 dat)
{
    u8 i;
    for(i=0; i<8; i++)
    {
        if(dat & 1)     IR_TxSpace(63);    //数据1对应 1.6875 + 0.5625 ms 
        else            IR_TxSpace(21);       //数据0对应 0.5625 + 0.5625 ms
        IR_TxPulse(21);         //脉冲都是0.5625ms
        dat >>= 1;              //下一个位
    }
}

//========================================================================
// 函数: void   PWM_config(void)
// 描述: PCA配置函数.
// 参数: None
// 返回: none.
// 版本: V1.0, 2012-11-22
//========================================================================
void    PWM_config(void)
{
		P_SW2 |= 0x80;
		
    PWM1_CCER1 = 0x00; //写 CCMRx 前必须先清零 CCxE 关闭通道
    PWM1_CCMR1 = 0x60; //设置 PWM1 模式1 输出

    PWM1_ARRH = 0x02; //设置周期时间
    PWM1_ARRL = 0x77;
    PWM1_CCR1H = 0;
    PWM1_CCR1L = 210; //设置占空比时间

//  PWM1_ENO = 0x02; //使能 PWM1N 输出
    PWM1_ENO = 0x01; //使能 PWM1P 输出
	
//  PWM1_PS = 0x01;  //高级 PWM 通道 1N 输出脚选择位, 0x00:P1.1, 0x01:P2.1, 0x02:P6.1
    PWM1_PS = 0x01;  //高级 PWM 通道 1P 输出脚选择位, 0x00:P1.0, 0x01:P2.0, 0x02:P6.0
	
    PWM1_BKR = 0x80; //使能主输出
	
//    PWM1_IER = 0x02; // 使能中断
    PWM1_CR1 |= 0x01; //开始计时
	
//		P_SW2 &= 0x7f;
}

/******************* PWM中断函数 ********************/
void PWM1_ISR() interrupt 26
{
    if(PWM1_SR1 & 0X02)
    {
        PWM1_SR1 = 0;
			
        if(--tx_cnt == 0)
        {
            PWM1_CCER1 = 0x00; //写 CCMRx 前必须先清零 CCxE 关闭通道
            PWM1_CCMR1 = 0x40; //设置 PWM4 强制为无效电平
            PWM1_CCER1 = 0x03; //使能 CC4E 通道, 低电平有效
            PWM1_IER = 0x00;   // 关闭中断
        }
		}
}

